
<?

global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");
require_once( $root->pathTo() . "_php/multiple-choice-meta.php");
require_once( $root->pathTo() . "_php/multiple-choice.php");


class AnswerAgent {

  var $answers_;

  function AnswerAgent() {
    $this->meta_ = new AnswerMeta();
    $this->answers_ = array();
  }  

  function load() {
    global $userid;

    $sqlUserId = $this->meta_->getSqlUserId($userid);
    $query = "select * from answers where lower(user_id) = $sqlUserId";
    $this->answers_ = $this->search($query);
    
  }    

  function get($question_id) {
    if (empty($this->answers_)) {
      $answer = "";
    } else {        
      $answer = empty($this->answers_[$question_id]) ? "" :$this->answers_[$question_id] ;
    }
    return $answer;
  }    


  function search($query) {
    global $root;
    $root->openDB();
    
    $result = mysql_query($query);
    $this->alertSql("search($query):failed");
    $answers = "";
    while ($row = mysql_fetch_array($result)) {
      $answers[$row["question_id"]] = $row["answer"];
    }
    return $answers;
  }  



  function save($qid,$userid,$date,$time,$answer) {
    global $root;

    $sqlUserId = $this->meta_->getSqlUserId($userid);
    $sqlQuestionId = $this->meta_->getSqlQuestionId($qid);

    

    $query = "select id from answers where lower(question_id) = $sqlQuestionId and lower(user_id) = $sqlUserId";
    $root->openDB();
    $result = mysql_query($query);
    $row = mysql_fetch_array($result);

    $doNothing = ($answer == "") && empty($row);
    $isNew = empty($row) && !$doNothing;
    $isExisting = !empty($row) && !$doNothing;

    if ($isNew) {
      $isSaved = $this->meta_->save($qid,$userid,$date,$time,$answer);
    } else if ($isExisting) {
      $id = $row["id"];
      $isSaved = $this->meta_->update($id,$qid,$userid,$date,$time,$answer);
    } else {
      $isSaved = false;
    }      

    return $isSaved;
  }    


  function isChecked($choice,$answer) {
    return stristr($answer,$choice) ? " checked " : "";
  }    

  function isRadioed($choice,$answer) {
    return $answer == $choice ? " checked " : "";
  }    

  function isRanked($choice,$rank,$answer) {
    $trueChoice = $choice . "-" . $rank;
    return $this->isChecked($trueChoice,$answer);
    
  }    

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("answer-agent.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("answer-agent.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("answer-agent.php",$msg);  
  } 

  
}  



?>