
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class MultipleChoice{

  var $id_;
  var $question_id_;
  var $letter_;
  var $choice_;


  function MultipleChoice() {
    $this->meta_ = new MultipleChoiceMeta();
  }  

  function init($question_id,$letter,$choice) {
    $this->question_id_ = $question_id;
    $this->letter_ = $letter;
    $this->choice_ = $choice;    
  }   

  function load($id) {
    $isOkay = $this->meta_->is($id);
    if ($isOkay) {
      $this->meta_->load($id);
      $this->id_ = $id;
      $this->init($this->meta_->question_id_,$this->meta_->letter_,$this->meta_->choice_);
    }
    return $isOkay;
  } 

  function save() {
    return $this->meta_->save($this->question_id_,$this->letter_,$this->choice_);
  }

  function update() {
    return $this->meta_->update($this->id_,$this->question_id_,$this->letter_,$this->choice_);
  }    

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("multiple-choice.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("multiple-choice.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("multiple-choice.php",$msg);  
  } 


 
}  



?>
