
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class QuestionMeta{

  var $id_;
  var $question_;
  var $type_;
  var $multple_choices_;

  var $alltypes_ = array("textarea","input","radio","checkbox","rank","opinion");

  function QuestionMeta() { }

  function set($id,$question, $type,$multiple_choices = "") {
    $this->id_ = $id;
    $this->question_ = $question;
    $this->type_ = in_array($type,$this->alltypes_) ? $type : $this->alltypes_[0];
    $this->multiple_choices_ = $multiple_choices;
  }  

  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($id) {
    global $root;
    $root->openDB();

    $sqlId = $this->getSqlId($id);

    $isOpinion = ($id == "0");

    $query = "select id from questions where lower(id) = $sqlId";
    $result = mysql_query($query);
    $this->alertSql("is($id):failed");
    $ans = (mysql_num_rows($result) > 0) || $isOpinion;
    return $ans;
  }   

  //```````````````````````
  // BROKER
  //```````````````````````


  function load($id) {
    if ($this->is($id)) {

      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);
      $query = "select * from questions where id = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("load($id):query failed");
      $ans = mysql_fetch_array($result);
      $this->alertSql("load($id):fetch array failed");

      $question = $ans["question"];
      $type = $ans["type"];
      
      if ($this->isMultipleChoice($type)) {
        $agent = new MultipleChoiceAgent();
        $multiple_choices = $agent->loadChoices($id);
      } else if ($this->isOpinion($type)) {
        $agent = new OpinionAgent();
        $multiple_choices = $agent->loadChoices($id);
      } else {
        $multiple_choices = "";
      }        

      $this->set($id,$question,$type,$multiple_choices);
    } else {
      $id = false;
    }
    return $id;
  }  

  function save($question,$type, $multiple_choices = "") {

    global $root;
    $root->openDB();

    $sqlQuestion = $this->getSqlQuestion($question);
    $sqlType = $this->getSqlType($type);

    $query = "insert into questions (question,type) values ($sqlQuestion,$sqlType)";
    $result = mysql_query($query);
    $this->alertSql("save():query failed");
    $id = mysql_insert_id();

    if ($this->isMultipleChoice($type)) {
      $agent = new MultipleChoiceAgent();
      $agent->saveChoices($id,$multiple_choices);
    }      

    return $id;
  }

  function update($id,$question,$type, $multiple_choices="") {

    if ($this->is($id)) {
      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);
      $sqlQuestion = $this->getSqlQuestion($question);
      $sqlType = $this->getSqlType($type);

      $query = "update questions set question=$sqlQuestion, type=$sqlType where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("update(): query failed");
      $ans = (mysql_errno() == false);

      if ($this->isMultipleChoice($type)) {
        $agent = new MultipleChoiceAgent();
        $agent->updateChoices($id,$multiple_choices);
      }        
      
    } else {
      $ans = false;
    }
    return $ans;
  }    

  function delete($id) {

    $sqlId = $this->getSqlId($id);
    
    if (!$this->is($id)) {
      $ans = false;
    } else {
      global $root;
     $root->openDB();


      $query = "delete from answers where lower(question_id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("delete($id): removal of related answers failed");
      $ans = (mysql_affected_rows() > 0);

      $query = "delete from questions where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("delete($id): removal of question failed");
      $ans = (mysql_affected_rows() > 0);

      $query = "delete from multiplechoices where lower(question_id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("delete($id): removal of multiplechoices failed");
      $ans = (mysql_affected_rows() > 0);
     
    }
    return $ans;
  }


  //```````````````````````
  // PRIVATE
  //```````````````````````

  function isMultipleChoice($type) {
    return ($type != "input" && $type != "opinion");
  }    

  function isOpinion($type) {
    return ($type == "opinion");
  }    

  function getSql($var) {
    $db = new DbMeta();
    return $db->getSqlQuotes($var);
  }    

  function getSqlId($value) {
    return $this->getSql($value);
  }    

  function getSqlQuestion($value) {
    return $this->getSql($value);
  }  

  function getSqlType($value) {
    return $this->getSql($value);
  }  


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("question-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("question-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("question-meta.php",$msg);  
  } 
  
}  



?>
