
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class Question{

  var $id_;
  var $question_;
  var $type_;
  var $multiple_choices_;

  var $meta_;  

  function Question($id = "") {
    $this->meta_ = new QuestionMeta();

    if ($id != "") {
      $this->load($id);
    }      
    
  }  

  
  function init($question,$type,$multiple_choices = "") {
    $this->question_ = $question;
    $this->type_ = $type;
    $this->multiple_choices_ = $multiple_choices;
  }   

  function load($id) {
    $isOkay = $this->meta_->is($id);
    if ($isOkay) {
      $this->meta_->load($id);
      $this->id_ = $id;
      $this->init($this->meta_->question_,$this->meta_->type_,$this->meta_->multiple_choices_);
    }
    return $isOkay;
  } 

  function save() {
    return $this->meta_->save($this->question_,$this->type_,$this->multiple_choices_);
  }

  function update() {
    return $this->meta_->update($this->id_,$this->question_,$this->type_,$this->multiple_choices_);
  }    

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("question.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("question.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("question.php",$msg);  
  } 


 
}  



?>
