
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");
require_once( $root->pathTo() . "_php/user-meta.php");
require_once( $root->pathTo() . "_php/user.php");


class UserAgent {

  var $meta_;
  var $ids_;

  function UserAgent() {
    $this->meta_ = new UserMeta();
    $this->ids_ = array();
  }  

  function register() {
    global $email,$pwd;

    if ($email == "") {
      $ans = "empty";
    } else if ($this->meta_->isEmail($email)) {
      $ans = "duplicate";
    } else {
      $this->meta_->save($email,$pwd);
      $ans = "added";
    }
    return $ans;
  }    

  function login() {
    global $email, $pwd;
    $loginOkay = $this->meta_->isLogin($email,$pwd);

    if ($email == "") {
      $ans = "empty";
    } else if (!$loginOkay) {
      $ans = "wrong";
    } else {
      $isLoaded = $this->meta_->loadByEmail($email);
      $ans = ($isLoaded != false) ? "okay" : "problem";
    }
    return $ans;
  }  

  function isConsent($id) {
    return false;
  }    



  //``````````````````````
  // SEARCH FUNCTIONALITY
  //``````````````````````   

  function all() {
    $query = "select * from users where 1";
    $this->search($query);    
  }    

  function getUsersThatHaveCompletedSurvey() {
    $questionAgent = new QuestionAgent();
    $num = $questionAgent->num();
    
    $query = "select * from users where question_id >= $num";
    $this->search($query);
  }    

  function get($ulow="1",$uhigh) {
    $where = "id >= $ulow and id <= $uhigh";
    $query = "select * from users where $where";
    $this->search($query);
  }    

  function num() {

    global $root;
    $root->openDB();

    $query = "select count(*) from users where id >= 1";
    $result = mysql_query($query);
    $row = mysql_fetch_array($result);
    return $row["count(*)"];
  }    


  function search($query,$normalize=true) {

    global $root;
    $root->openDB();
    
    $result = mysql_query($query);
    $this->alertSql("search($query)");
    while ($row = mysql_fetch_array($result)) {
      $this->insert($row["id"]);
    }
    if ($normalize) {
      $this->normalize();
    }
  }  

  function insert($id) { 
    array_push($this->ids_,$id);  
  }    

  function next() { 
    $tmp = each($this->ids_);
    return ($tmp == false) ? $tmp : $tmp["value"];
  }    

  function normalize() {
    $this->ids_ = array_unique($this->ids_);
    sort($this->ids_);
  }  

  function numResults() {
    if (!isset($this->ids_)) {
      $num = 0;
    } else {      
      $num = count($this->ids_);
    }
    return $num;
  }    

  function isNoResults() {
    return ($this->numResults() == 0);
  }    











  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("user-agent.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("user-agent.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("user-agent.php",$msg);  
  } 


  
}  



?>