
<?


class HTML {

  var $html_;
  var $body_;

  var $meta_;
  var $form_;
  var $login_;
  var $survey_;

  var $hidden_;



  function HTML($html = "new") {
    $this->set($html);
    $this->meta_ = new HTMLMeta();
    $this->form_ = new Form();
    $this->login_ = new Login();
    $this->survey_ = new Survey();
    $this->hidden_ = "hidden";
  }    

  function set($html) {
    $this->html_ = $html;
  }    

  function showIntro() {

    $html = $this->login_->process();

    $this->set($html);
    if ($html == $this->meta_->new_) {
      $this->showSignIn();

    } else if ($html == $this->meta_->consenting_) {
      $this->showConsent();

    } else if ($html == $this->meta_->agreed_) {
      $this->showAgree();

    } else if ($html == $this->meta_->disagreed_) {
      $this->showDisagree();

    } else if ($html == $this->meta_->incorrect_) {
      $this->showIncorrectSignIn();

    } else if ($html == $this->meta_->winner_) {
      $this->showWinner();
      
    } else {
      $this->showError();
    }      
  }    

  function showMe() {
  ?>
    Andrew Forward<br>
    University of Ottawa<br>
    T (613) 255 - 3492<br>
    E aforward@site.uottawa.ca<br>

  <?
  }    

  function showWinner() {

    global $root;
    $page = $root->page();

    ?>

    <html>
    <head>
    <title><?= $this->html_ ?></title>
    <? $root->css(); $root->jscripts(); ?>
    </head>

    <body>
    <table width=70% align=center><tr><td><br><br><br>
    Congratulations to Robin Rowe; the winner of the Rio-One MP3 Player.<br><br>
    Thank you to everyone that participated, your help was extremely helpful.
    Please check back this summer (or email me) to see the survey results and my progress with this subject.<br><br>

    If you are interested in helping further, please contact me (see below).<br><br>

    TO COMPLETE THE SURVEY, please <a href="<?= "$page?welcome=1"?>">click here to complete the survey</a>.<br><br>
    <? $this->showMe() ?>

    </td></tr></table>
    </body>
    </html>
 
    <?    
  }    


  function showSignIn() {

    global $root,$email;    

    $hidden = $this->hidden_;
      
    ?>

    <html>
    <head>
    <title><?= $this->html_ ?></title>
    <? $root->css(); $root->jscripts(); ?>
    </head>

    <body>
    <table align=center width=80%>
    <tr><td>
    <br>
    <b>Dear Participant</b>,<br><br>
  
    My name is Andrew Forward (<a href="mailto:aforward@site.uottawa.ca">aforward@site.uottawa.ca</a>), 
    a master's student in Computer Science at the University of Ottawa.<br><br>
    
    My research topic concerns the effectiveness and relevance of software
    documentation.  Based on your experience in the software field, I would
    appreciate if you could take the time to complete an online questionnaire.<br><br>

    Prior to beginning the survey, you may either register with the system
    by providing your email address (and an optional password) or you may
    continue as an anonymous user. The only purpose of giving your email is so
    it would allow you to leave the system and then later come back and resume
    the survey. The email address will not be used for any other purpose and
    will be discarded once all the data is gathered. The optional password
    prevents the possibility of others completing the survey masquerading as
    you.<br><br>

    Following the above step, you will be asked to consent to participating in
    this survey.  If you agree with the consent form you will be able to continue
    with the survey.<br><br> 

    Once you have entered the survey you will be presented with a set of
    questions which I ask that you answer to the best of your abilities.  At
    any point you may quit the questionnaire and / or skip questions you do
    not wish to complete.<br><br>

    <form name=fm method=post action="<?=$root->page()?>" onSubmit="return confirmLogin(fm);">
    email (optional):<br>
    <input name=email value="<?=$this->form_->value($email);?>"><br><br>

    password (optional):<br>
    <input type=password name=pwd ><br><br>
    <input type=submit name=su value="<?=$this->meta_->continue_?>" class="submit" title="Click here to register for the survey">
    <input type="<?=$hidden?>" name=id>
    <br>
    </form>
    </td></tr>
    </table>
    </body>
    </html>
    <?
  }    

  function showConsent() {

    global $root;

    $hidden = $this->hidden_;
    $userid = $this->login_->get();
    
    ?>
    <html>
    <head>
    <title><?= $this->html_ ?></title>
    <? $root->css(); $root->jscripts(); ?>
    </head>

    <body>
    <table width=80% align=center>
    <tr><td>
    <form name=fm action="<?= $root->page(); ?>" method=post>
    <br>
    <b>Informed Consent</b><br><br>

    The following consent form is for a research experiment conducted by Andrew Forward of the KBRE group, School of Information Technology and Engineering, University of Ottawa.  The project is under the supervision of Dr. Timothy C. Lethbridge (<a href="tcl@site.uottawa.ca">tcl@site.uottawa.ca</a>).  This aspect of the research consists of an on-line questionnaire.<br><br>

    The goal of the questionnaire is to gain a better understanding of the role of software documentation in the software development process.   To help us understand how and when documentation is useful and relevant, we want to ask you some questions.<br><br>

    The survey will take about 20 - 30 minutes to complete.<br><br>

    I understand that this activity has risk.  It may cause me slight frustration, as the questions posed might be difficult or confusing to answer.  All questions are voluntary and you need only answer those questions that you wish to. If you agree to participate in the survey, you can change your mind at any time. <br><br>

    All your answers to the survey questions will be completely confidential. Your answers will be coded so your name will not be on the survey.  This research will yield useful data for the design of documentation and documentation tools.<br><br>

    If you have any questions, please call Andrew Forward (613) 255 - 3492, the research assistant in charge of this project, or you may email him at <a href="mailto:aforward@site.uottawa.ca">aforward@site.uottawa.ca</a>.<br><br>

    Questions concerning the ethical conduct of this research may be addressed to Catherine Lesage at (613) 562-5387.<br><br>


    <input type=submit name=su value="<?= $this->meta_->IAgree_ ?>" class="submit"> &nbsp; &nbsp;
    <input type=submit name=su value="<?= $this->meta_->IDisagree_ ?>" class="submit"> &nbsp; &nbsp;<br>
    <input type="<?= $hidden?>" name=userid value="<?=$this->form_->value($userid);?>">  
    </form>
    </td></tr>
    </table>
    </body>
    </html>
    <?


  }    


  function showAgree() {
    ?><script>location.href='survey.php?userid=<?= $this->login_->id_ ?>&start=<?= $this->login_->question_id_?>&num=10'</script><?
  }

  function showDisagree() {
    ?><script>location.href='index.php'</script><?
  }


  function showIncorrectSignIn() {
    ?><script>alert("Incorrect Password");</script><?
    $this->showSignIn();
  }  

  function showError() {

    global $root;  


    ?>

    <html>
    <head>
    <title><?= $this->html_ ?></title>
    <? $root->css(); $root->jscripts(); ?>
    </head>
    <body>
    <?= $this->debug("unknown type: $this->html_") ?>
    </body>
    </html>
    <?
  }


  function showSurvey() {

    global $num;


    $html = $this->survey_->process();
    $start = $this->survey_->questionid_;

    $form = new Form();
    $num = $form->value($num,$this->survey_->num());

    $this->set($html);

    $isAnswering = $html == $this->meta_->answering_;
    $isDone = $html == $this->meta_->done_;
    
    if ($isAnswering) {
      $this->showQuestions($start,$num);

    } else if ($isDone) {
      $this->showDone();

    } else {
      $this->showError();
    }  
    ?>
    </body>
    </html>
    <?

  }    


  function showQuestion($id) {
    $hidden = $this->hidden_;

    $question = new Question();
    $agent = new AnswerAgent();
    $agent->load();
    
    $isOkay = $question->load($id);

    $num = $this->survey_->num();

    $answer["name"] = "answer" . $id;
    $answer["form"] = "fm." . $answer["name"];
    $answer["multi"] = "multiplechoice" . $id;
    $answer["value"] = $agent->get($id);
    ?>
    
    <table width=80% align=center border=0>
      <tr style="font-weight:bold;">
        <td ><br>Question <?= $question->id_ ?> of <?= $num ?></td>
      <tr>

      <tr>
        <td>
        <?= $question->question_?>
        <input type="<?=$hidden?>" name=questionid[] value="<?=$id?>">
        </td>
      </tr>

      <tr>      
        <td>
        <?
        
        $type = $question->type_;

        if ($type == "textarea" || $type == "") {
          ?><textarea  name="<?=$answer["name"]?>" cols=50 rows=10 wrap=soft><?=$answer["value"]?></textarea><?

        } else if ($type == "input") {
          ?><input name="<?=$answer["name"]?>" value="<?=$answer["value"]?>"><?

        } else if ($type == "radio" or $type == "opinion") {
          
          foreach ($question->multiple_choices_ as $choice) {
            $isChecked = $agent->isRadioed($choice->letter_,$answer["value"]);
            ?><input type="radio" name="<?=$answer["multi"]?>" value="<?= $choice->letter_?>" <?= $isChecked ?> onClick="<?=$answer["form"]?>.value = this.value;"> &nbsp; <?= $choice->choice_?><br><?
          }
          ?><input name="<?=$answer["name"]?>" type="<?=$hidden?>" value="<?=$answer["value"]?>" ><?


        } else if ($type == "checkbox") {          
          
          foreach ($question->multiple_choices_ as $choice) {
            $isChecked = $agent->isChecked($choice->letter_,$answer["value"]);
            ?><input type="checkbox" name="<?=$answer["multi"]?>" value="<?= $choice->letter_?>" <?= $isChecked ?> onClick="updateChoices(<?=$answer["form"]?>,this)"> &nbsp; <?= $choice->choice_?><br><?
          }
          ?><input name="<?=$answer["name"]?>" type="<?=$hidden?>" value="<?=$answer["value"]?>"><?

        } else if ($type == "rank") {
          ?>
          <table>
            <tr align=center>
              <td>1</td>
              <td>2</td>
              <td>3</td>
              <td>4</td>
              <td>5</td>
              <td>&nbsp;</td>
              <td>N/A</td>
              <td>&nbsp;</td>
          
            </tr>
          <?
   
          foreach ($question->multiple_choices_ as $choice) {
            ?><tr><?
            for ($rank=1; $rank<=5; $rank++) {
              $isRanked = $agent->isRanked($choice->letter_,$rank,$answer["value"]);
              ?><td><input type=radio value="<?=$rank ?>" name="<?= $answer["name"] . ":" . $choice->letter_?>" <?= $isRanked ?> onClick="updateRank(<?=$answer["form"]?>,this)" ></td><?
            }
            $rank = "na";
            $isRanked = $agent->isRanked($choice->letter_,$rank,$answer["value"]);
            ?>
            <td>&nbsp;</td>
            <td><input type=radio value="<?=$rank ?>" name="<?= $answer["name"] . ":" . $choice->letter_?>" <?= $isRanked ?> onClick="updateRank(<?=$answer["form"]?>,this)" ></td>
            <td>&nbsp; <?= $choice->choice_?><br></td></tr><?
          }
          ?></table><input name="<?=$answer["name"]?>" type="<?=$hidden?>" value="<?=$answer["value"]?>"> <?
        }         
        ?>

        </td>
      <tr>

    </table>

    <?


  }    


  function showQuestions($low,$num) {

    global $root;

    $hidden = $this->hidden_;
    $high = $low + $num - 1;

    $question = new Question();
    $question->load($this->survey_->questionid_);
    
    ?>
    <html>
    <head>
    <title>question <?= $question->id_ ?></title>
    <? $root->css(); $root->jscripts(); ?>
    </head>
    <body>
    
    <form name=fm action="<?= $root->page() ?>" method=post >
    <input type="<?=$hidden?>" name="num" value="<?=$num?>">
    <?
    for ($i=$low;$i<=$high;$i++) {

      $question = new QuestionMeta();
      $isQuestion = $question->is($i);

      if ($isQuestion) {
        $this->showQuestion($i);
        print "<br>";
      }
    }      
    ?>
 
    <table width=80% align=center border=0>
      <tr>
        <td>
        <input type=submit name="answer" value="Next" style="cursor:hand"> &nbsp;
        <input type=submit name="answer" value="Back" style="cursor:hand"> &nbsp;

<!--
        <select name=num>
          <option id="<?=$num?>">Show next <?= $num ?> questions
          <option id=1>Show next questions
          <option id=10>Show next 10 questions
          <option id=20>Show next 20 questions
          <option id="<?=$this->survey_->num()?>">Show all remaining
        </select>
-->
        </td>
      </tr>
      <tr>
        <td>
        <input type="<?=$hidden?>" name=userid value="<?= $this->survey_->userid_?>">
        </td>
      </tr>
    </table>
    
    </form>
    </body>
    </html>

    <?
  }    


  function showDone() {

    global $root;

    $hidden = $this->hidden_;
    ?>
    <html>
    <head>
    <title>done</title>
    <? $root->css(); $root->jscripts(); ?>
    </head>
    <body>
    <table width=80% align=center>
      <tr>
        <td>
        <br><br>
        Thank you for participating in this survey.<br><br>
        To receive a summary of the findings of this research, or if you are interested in helping further, please contact me (see below).<br><br>
        <? $this->showMe() ?>
    
        </td>
      </tr>
    </table>
    <input type="<?=$hidden?>" name=userid value="<?= $this->survey_->userid_?>">
    </body>
    </html>
    <?
  }

  function refer_email() {

    $newline = "%0D%0A";
    $double = $newline . $newline;

    $userid = $this->login_->get();
    $user = new User();
    $user->load($userid);
    $email = (!empty($user->email_)) ? $user->email_ : "";

    $to = "aforward@site.uottawa.ca";
    $from = $email;
    $subject = " [ docsurvey ] Referral by $email";

    $referral = "This referral is from $email.  S/he thinks this might interest you.";

    $msg = "Hello,$double" .
    "My name is Andrew Forward.  I am a graduate student in computer science at the University of Ottawa in Canada (www.uottawa.ca).$double" .
    "As part of my research, I am conducting a survey regarding software documentation.  In particular, I am looking at documentation from a software developer perspective as oppose to end users.$double" .
    "I would appreciate if you would complete the on-line survey and provide feedback about your experiences.  As an incentive, all participants that complete the survey and feedback form are eligible to win a portable mp3 player.$double" .
    "The survey is available at:$newline" .
    "http://www.site.uottawa.ca:4333/docsurvey/$double" .
    "The feedback form is an email link available once you complete the survey.$double" .
    "The deadline to complete this survey is Tuesday, April 23, 2001 at 10:00 am.$double" .
    "Should you have any questions, please contact me at aforward@site.uottawa.ca or call (613) 255 3492.$double" .
    "Thank you,$newline" .
    "andrew f" ;

    $body = $referral . $double ."``````````````" . $double . $msg;

    print "<a href='mailto:?cc=aforward@site.uottawa.ca&from=$from&subject=$subject&body=$body' title='Click here to refer a friend to complete this survey'>refer a friend</a>";



  }    


  function mp3_email() {

    $newline = "%0D%0A";
    $double = $newline . $newline;

    $userid = $this->login_->get();
    $user = new User();

    $user->load($userid);
    $email = (!empty($user->email_)) ? $user->email_ : "";

    $to = "aforward@site.uottawa.ca";
    $from = $email;
    $subject = " [ docsurvey ] Questionnaire Completed by $email";

    $body = "Thank you for participating in this survey.$double" .
                "To be eligible for the draw of the MP3 player, please complete and remit the following to aforward@site.uottawa.ca by 11:00 AM (EST) Tuesday, April 23, 2002.$double" .
                "1. What is your login email?$newline$email$double" .
                "2. What is your full name?$double" .
                "3. Did you like the survey?  Why?$double" .
                "4. Did you find errors in the survey?  If so, what?$double" .
                "5. Did you find any questions irrelevant and / or confusing?  If so which, and why?$double" .
                "The winner will be notified by email the week of April 22, 2002.  This information will also be posted at http://www.site.uottawa.ca:4333/docsurvey/$double" .
                "`````````````$newline Andrew Forward$newline University of Ottawa$newline`````````````";

    print "<a href='mailto:$to?from=$from&subject=$subject&body=$body' title='Click here to be eligible to win an MP3 player'>complete this form</a>";

  }    


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("_html.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("_html.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("_html.php",$msg);  
  } 



 
}


?>






