
<?


class Login {

  var $form_;
  var $html_;

  var $id_;
  var $question_id_;

  function Login() {
    $this->form_ = new Form();
    $this->html_ = new HTMLMeta();
    $this->set();
  }

  function set($id=false) {
    global $userid;
    if (!empty($userid)) {
      $this->id_ = $userid;
    } else {
      $this->id_ = $id;
    }
    $user = new UserMeta();

    $this->question_id_ = $user->nextQuestion($this->id_);
  }    

  function get() {

    return $this->id_;
  }    

  function process() {

    global $su,$suConsent,$email,$pwd,$welcome;
    $continue = $this->html_->continue_;

    $user = new UserMeta();


    
    $isNew = (empty($su));
    $isWinner = (empty($welcome)) && $isNew;
    $isSignIn = !$isWinner && $isNew;
    $isConsenting = !$isNew && ($su == $this->html_->IAgree_ || $su == $this->html_->IDisagree_);
    $isLoggingIn = !$isNew && !$isConsenting;

    if ($isWinner) {
      //$html = $this->html_->winner_;
      $html = $this->html_->new_;
      
    } else if ($isSignIn) {
      $html = $this->html_->new_;

    } else if ($isLoggingIn) {

      $id = $this->processLogin();
      $this->set($id);
      $isSignedIn = ($user->is($this->get()));
      $isIncorrectLogin = !$isSignedIn;
      $isConsentAgreed = $isSignedIn && $user->isConsent($this->get());
      $isConsenting = $isSignedIn && !$isConsentAgreed;

      if ($isIncorrectLogin) {
        $html = $this->html_->incorrect_;
      } else if ($isConsenting) {
        $html = $this->html_->consenting_;
      } else if ($isConsentAgreed) {
        $html = $this->html_->agreed_;
      }        
      
    } else if ($isConsenting) {
      $html = $this->processConsent();
    }      

    return $html;
  }  


  function processLogin() {
    global $id,$HTTP_SERVER_VARS;
    global $email,$pwd;

    if ($HTTP_SERVER_VARS["CONTENT_LENGTH"] != 0) {

      $meta = new UserMeta();

      

      $isAnonymous = empty($email);
      $isNewUser = !$isAnonymous && !$meta->isEmail($email);
      $isSignedIn = !$isNewUser && $meta->isLogin($email,$pwd);
      $isIncorrectSignIn = !$isSignedIn;

      if ($isAnonymous) {
        $id = $meta->defaultt();

      } else if ($isNewUser) {
        $id = $meta->save($email,$pwd);

      } else if ($isSignedIn) {
        $id = $meta->loadByEmail($email);

      } else if ($isIncorrectSignIn) {
        $id = false;
      }        
    } else {
      $id = false;
    }
    return $id;
  }

  function processConsent() {

    global $su;
    $user = new UserMeta();

    if (empty($su)) {
      $html = $this->html_->consenting_;
    }else if ($su == $this->html_->IAgree_) {
      $user->consented($this->get());
      $html = $this->html_->agreed_;
    } else if ($su == $this->html_->IDisagree_) {
      $html = $this->html_->disagreed_;
    }      
      
    return $html;

  }

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("_login.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("_login.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("_login.php",$msg);  
  } 

 
}


?>






