
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class Answer{

  var $id_;
  var $question_id_;
  var $user_id_;
  var $date_;
  var $time_;
  var $answer_;

  var $meta_;  

  function Answer() {
    $this->meta_ = new AnswerMeta();
  }  

  function init($question_id,$user_id,$date,$time,$answer) {
    $this->question_id_ = $question_id;
    $this->user_id_ = $user_id;
    $this->date_ = $date;
    $this->time_ = $time;
    $this->answer_ = $answer;
  }  

  //```````````````````````
  // BROKER
  //```````````````````````

  function load($id) {
    $isOkay = $this->meta_->is($id);
    if ($isOkay) {
      $this->meta_->load($id);
      $this->id_ = $id;
      $this->init($this->meta_->question_id_,$this->meta_->user_id_,$this->meta_->date_,$this->meta_->time_,$this->meta_->answer_);
    }
    return $isOkay;
  } 

  function save() {
    return $this->meta_->save($this->question_id_,$this->user_id_,$this->date_,$this->time_,$this->answer_);
  }

  function update() {
    return $this->meta_->update($this->id_,$this->question_id_,$this->user_id_,$this->date_,$this->time_,$this->answer_);
  }  
  

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("answer.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("answer.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("answer.php",$msg);  
  } 
  
}  



?>
