
<?

global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class Broker{

  var $id_;
  var $names_;
  var $table_;
  var $sql_;

  var $ans_;

  function Broker($table,$id,$names) {
    $this->table_ = $table;
    $this->id_ = $id;
    $this->names_ = $names;
  }

  function set($values) {
    $this->ans_ = $values;
  }  


  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($check_id) {

    global $root;
    $root->openDB();

    $table = $this->table_;
    $id= $this->id_;
    $sql = $this->names_;
    
    $sqlId = $this->getSql($check_id,$sql[$id]);
    
    $query = "select $id from $table where lower($id) = $sqlId";
    $result = mysql_query($query);
    $this->alertSql("is($check_id):failed");
    $ans = (mysql_num_rows($result) > 0);
    return $ans;
  } 


  function get($name = "<all>") {

    if (!empty($this->ans_)) {
      $value = ($name == "<all>") ? $this->ans_ : $this->ans_[$name];
    } else {
      $value = false;
    }
    return $value;
  }    


  //```````````````````````
  // BROKER
  //```````````````````````

  function load($load_id) {
    $id = $this->loadBy($this->id_,$load_id);
    return $id;
  }  

  function loadBy($name,$value) {
    global $root;
    $root->openDB();

    $table = $this->table_;
    $sql = $this->names_;
    $sqlName = $this->getSql($value,$sql[$name]);

    $query = "select * from $table where lower($name) = $sqlName";
    $result = mysql_query($query);
    $this->alertSql("loadBy($name,$value):query failed");
    $ans = mysql_fetch_array($result);
    $this->alertSql("loadBy($name,$value):fetch array failed");

    if (!empty($ans) ) {
      $this->set($ans);
      $loadId = $ans[$this->id_];
    } else {
      $loadId = false;
    }
    
    return $loadId;

  }    

  

  function save($values) {

    global $root;
    $root->openDB();

    $names = $this->getInsertNames();
    $sqlValues = $this->getInsertValues($values);
    $table = $this->table_;

    $query = "insert into $table ($names) values ($sqlValues)";
    $result = mysql_query($query);
    $this->alertSql("save():query failed");
    $answer_id = mysql_insert_id();
    $this->load($answer_id);
    return $answer_id;
  }  


  function update($update_id,$values){

    if ($this->is($update_id)) {

      global $root;
      $root->openDB();

      $id = $this->id_;      
      $sqlId = $this->getSqlId($update_id);
      $table = $this->table_;
      $updates = $this->getUpdateValues($values);

      $query = "update $table set $updates where lower($id)=$sqlId";

      $result = mysql_query($query);
      $this->alertSql("update(): query failed");
      $ans = (mysql_errno() == false);
      $this->load($update_id);

      $ans = $update_id;
      
    } else {
      $ans = false;
    }
    return $ans;
  }    

  function delete($delete_id) {

    if ($this->is($delete_id)) {
      global $root;
      $root->openDB();

      $id = $this->id_;
      $table = $this->table_;
      $sqlId = $this->getSqlId($delete_id);
      
      $query = "delete from $table where lower($id) = $sqlId";
      $result = mysql_query($query);
      $ans = (mysql_affected_rows() > 0);
    } else {
      $ans = false;
    }      
    return $ans;
  }

  

  //```````````````````````
  // PRIVATE
  //```````````````````````

  function getSqlId($value) {
    $sql = $this->names_;
    $id = $this->id_;
    $sqlId = $this->getSql($value,$sql[$id]);
    return $sqlId;
  }    

  function getSql($value,$type = "text") {

    $db = new DbMeta();
    $sqlValue = "";

    if ($type == "text") {
      $sqlValue = $db->getSqlQuotes($value);  
    } else if ($type == "int") {
      $sqlValue = $db->getSqlQuotes($value);
    } else if ($type == "date") {
      $sqlValue = $db->getSqlDate($value);
    } else if ($type == "time") {
      $sqlValue = $db->getSqlTime($value);
    } else {
      $sqlValue = $db->getSqlQuotes($value);
    }      

    return $sqlValue;

  }    

  function getSqlArray($values) {
    $sql = $this->names_;
    $sqlArr = array();
    foreach ($values as $key => $val) {
      $type = $sql[$key];
      $sqlValue = $this->getSql($val,$type);
      $sqlArr[$key] = $sqlValue;
    }
   
    return $sqlArr;
  }    


  function getInsertNames() {

    $id = $this->id_;
    $names = $this->names_;    
    $namesArr = array();

    foreach ($names as $name => $type) {
      if ($name != $id) {
        array_push($namesArr,$name);
      }
    }

    $format = new Format();
    $str = $format->array_delimit($namesArr,",");
    return $str;
  }    

  function getInsertValues($values) {
    $sqlArr = $this->getSqlArray($values);
    $format = new Format();
    $str = $format->array_delimit($sqlArr,",");
    return $str;
  }  

  function getUpdateValues($values) {

    $sqlArr = $this->getSqlArray($values);
    $updateArr = array();

    foreach ($sqlArr as $name => $sqlValue) {
      $element = "$name = $sqlValue";
      array_push($updateArr,$element);
    }

    $format = new Format();
    $str = $format->array_delimit($updateArr,",");
    return $str;

  }    


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("broker.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("broker.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("broker.php",$msg);  
  } 
  
}  



?>
