<?


class DB {

  var $dbname_;
  var $userid_;
  var $pwd_;
  var $server_;
  var $db_;

  var $meta_;

  function DB($dbname,$userid,$pwd,$server="localhost") {
    $this->meta_ = new DBMeta();
    $this->set($dbname,$userid,$pwd,$server);
  }  

  function set($dbname,$userid,$pwd,$server) {
    $this->dbname_ = $dbname;
    $this->userid_ = $userid;
    $this->pwd_ = $pwd;
    $this->server_ = $server;
    $this->close();
  }    

  function isOpen() {
    return $this->db_ != false;
  }    

  function open() {
    if (!$this->isOpen()) {
      $this->db_ = $this->meta_->open($this->dbname_,$this->userid_,$this->pwd_,$this->server_);
    }
    return $this->db_;
  }    

  function close() {
    if (!isset($this->db_)) {
      $this->db_ = false;
    } else if($db != false) {
      $this->meta_->close($this->db_);
    }
  }


  
}

class DBMeta {

  function DBMeta() { }  

  function open($dbname,$userid,$pwd,$server) {
    $db = @mysql_connect($server,$userid,$pwd);
    if (!$db) $this->alert("failed to open $server");
    mysql_select_db($dbname);
    $this->alertSql("DBMeta.open($dbname,$userid,$pwd,$server):unable to select $dbname");
    return $db;
  }

  function close($db) {
    mysql_close($db);
  } 

  function getSqlLikeQuotes($var) {
    $newVar = "%$var%";
    return sqlQuotes($newVar);
  }  

  function getSqlQuotes($var) {
    $newA = "\"";
    $a = (string)$var;
    for ($i=0; $i < strlen($a); $i++) {

      if ($a[$i] == "'") {
        //$newA = $newA . "''";
        $newA = $newA . $a[$i];
      } else if (strcmp(mysql_escape_string($a[$i]),$a[$i]) != 0) {
        //$newA = $newA . mysql_escape_string($a[$i]);
        $newA = $newA . $a[$i];
      } else {
        $newA = $newA . $a[$i];
      }
    }      
    $newA = $newA . "\"";
    return $newA;
    
  }  

  function getSqlDate($value) {
    return $value == "" ? "now('')" : $this->getSqlQuotes($value);
  }

  function getSqlTime($value) {
    return $value == "" ? "now('')" : $this->getSqlQuotes($value);
  }    

  function getToday() {
    $format = new Format();
    $theDate = getdate();
    $today = $format->year($theDate["year"]) . "-" . $format->month($theDate["mon"]) . "-" . $format->day($theDate["mday"]);
    return $today;
  }

  function getTime() {
    $theDate = getdate();
    $time = $theDate["hours"] . ":" . $theDate["minutes"] . ":" . $theDate["seconds"];
    return $time;
  }    


  function debug($msg) {
    $debug_ = new Debug();
    $debug_->println("db.php",$msg);
  }

  function debug_r($msg) {
    $debug_ = new Debug();
    $debug_->println_r("db.php",$msg);
  }   

  function alert($msg) {
    $debug_ = new Debug();
    $debug_->alert("db.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("db.php", $msg);
  }    


}


  function openAnyDB($dbname,$u,$p,$server="24.42.138.221") {

    $debug = new Debug();

    if (!isset($db)) {
      $db = @mysql_connect($server,$u,$p);
      if (!$db) alert("failed to open database");
      mysql_select_db($dbname);
      $debug->alertSql("db.php","openDB():failed");
    }

    return $db;
    
  }

  function closeAnyDB($db) {
    if ($db != false) {
      mysql_close($db);
    }
  }  

  function sqlLikeQuotes($var) {
    $newVar = "%$var%";
    return sqlQuotes($newVar);
  }  

  function sqlQuotes($var) {

    $newA = "'";

    $a = (string)$var;

    for ($i=0; $i < strlen($a); $i++) {
      if (strcmp(mysql_escape_string($a[$i]),$a[$i]) != 0) {
        $newA = $newA . mysql_escape_string($a[$i]);
      } else {
        $newA = $newA . $a[$i];
      }
    }      
    $newA = $newA . "'";
    return $newA;
  }    




?>
