
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class MultipleChoiceMeta{

  var $id_;
  var $question_id_;
  var $letter_;
  var $choice_;

  var $question_meta_;  

  function MultipleChoiceMeta() {
    $this->question_meta_ = new QuestionMeta();
  }

  function set($id,$question_id,$letter, $choice) {
    $this->id_ = $id;
    $this->question_id_ = $question_id;
    $this->letter_ = $letter;
    $this->choice_ = $choice;
  }  

  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($id) {

    global $root;
    $root->openDB();
    
    $sqlId = $this->getSqlId($id);
    
    $query = "select id from multiplechoices where lower(id) = $sqlId";
    $result = mysql_query($query);
    $this->alertSql("is($id):failed");
    $ans = (mysql_num_rows($result) > 0);
    return $ans;
  }   

  //```````````````````````
  // BROKER
  //```````````````````````

  function load($id) {
    if ($this->is($id)) {

      global $root;
      $root->openDB();


      $sqlId = $this->getSqlId($id);

      $query = "select * from multiplechoices where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("load($id):query failed");
      $ans = mysql_fetch_array($result);
      $this->alertSql("load($id):fetch array failed");
      $this->set($id,$ans["question_id"],$ans["letter"],$ans["choice"]);
      $ans = $id;
    } else {
      $ans = false;
    }
    return $ans;
  }  

  function save($question_id,$letter,$choice) {

    $isQuestion = $this->question_meta_->is($question_id);
    
    if ($isQuestion) {
      global $root;
      $root->openDB();

      $sqlQuestionId = $this->getSqlQuestionId($question_id);
      $sqlLetter = $this->getSqlLetter($letter);
      $sqlChoice = $this->getSqlChoice($choice);
      $query = "insert into multiplechoices (question_id,letter,choice) values ($sqlQuestionId,$sqlLetter,$sqlChoice)";
      $result = mysql_query($query);
      $this->alertSql("save():query failed");
      $id = mysql_insert_id();
      $ans = $id;
    } else {
      $ans = false;
    }
    return $ans;
  }

  function update($id,$question_id,$letter,$choice) {

    $isMultipleChoice = $this->is($id);
    $isQuestion = $this->question_meta_->is($question_id);

    if ($isMultipleChoice && $isQuestion ) {

      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);
      $sqlQuestionId = $this->getSqlQuestionId($question_id);
      $sqlLetter = $this->getSqlLetter($letter);
      $sqlChoice = $this->getSqlChoice($choice);
      
      $query = "update multiplechoices set question_id=$sqlQuestionId, letter=$sqlLetter, choice=$sqlChoice where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("update(): query failed");
      $ans = (mysql_errno() == false);
    } else {
      $ans = false;
    }
    return $ans;
  }    

  function delete($id) {

    if ($this->is($id)) {
      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);

      $query = "delete from answers where lower(answer) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("delete($id): removal of related answers failed");
      $ans = (mysql_affected_rows() > 0);

      $query = "delete from multiplechoices where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("delete($id): removal of MultipleChoice failed");
      $ans = (mysql_affected_rows() > 0);
    } else {
      $ans = false;
    }      
    return $ans;
  }

  //```````````````````````
  // PRIVATE
  //```````````````````````

  function getSql($var) {
    $db = new DbMeta();
    return $db->getSqlQuotes($var);
  }    

  function getSqlId($value) {
    return $this->getSql($value);
  }    

  function getSqlQuestionId($value) {
    return $this->getSql($value);
  }  

  function getSqlLetter($value) {
    return $this->getSql($value);
  }  

  function getSqlChoice($value) {
    return $this->getSql($value);
  }  


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("multiple-choice-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("multiple-choice-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("multiple-choice-meta.php",$msg);  
  } 
  
}  



?>
