
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");
require_once( $root->pathTo() . "_php/question-meta.php");
require_once( $root->pathTo() . "_php/question.php");


class ResultAgent {

  var $questions_;
  var $cols_;

  
  function ResultAgent($start="1",$num="all") {
    $this->load($start,$num);
  }  

  function load($start,$num) {
    $this->questions_ = $this->loadQuestions($start,$num);
    $this->cols_ = $this->getCols($this->questions_);
  }    

  function getUsersAnswer($user,$question,$letter) {
    $uid = $user->id_;
    $qid = $question->id_;
    $type = $question->type_;
    $ans = $this->getAnswer($uid,$qid,$letter,$type);
    return $ans;
  }    

  function getAnswer($uid,$qid,$letter,$type) {

    $isMulti = $type == "rank" || $type == "checkbox";

    $answer = "";

    if (!$isMulti) {
      $query = "select answer from answers a, users u where a.user_id = $uid and a.question_id = $qid and u.question_id > 39";
      $result = mysql_query($query);
      $ans = mysql_fetch_array($result);

      if (!empty($ans)) {
        $isRadio = ($qid != $letter);
        $isAnswered = !$isRadio || ($isRadio && $ans["answer"] == $letter);
        $answer = $isAnswered ? $ans["answer"] : "";
      } else {
        $answer = "";
      }        

    } else {
      $query = "select answer from multiplechoiceanswers where user_id = $uid and question_id = $qid and letter = '$letter'";
      $result = mysql_query($query);
      $ans = mysql_fetch_array($result);
      $answer = !empty($ans) ? $ans["answer"] : "";
    }
    
    return $answer;
  }

  function getQuestions() {
    return $this->questions_;
  }    

  function loadQuestions($start,$num) {

    $limit = ($num == "all") ? "limit $start" : "limit $start, $num";      

    global $root;
    $root->openDB();
    $query = "select id from questions where 1 $limit";
    $result = mysql_query($query);

    while($row = mysql_fetch_array($result)) {
      $qid = $row["id"];
      $q = new Question();
      $q->load($qid);
      $questions[$qid] = $q;
    }

    return $questions;    

  }    

  function getCols($questions) {

    $count = 0;

    foreach ($questions as $q) {
      $num = empty($q->multiple_choices_) ? 1 : count($q->multiple_choices_) ;
      $count += $num;
    }

    return $count;
  }    

  function isMultipleChoice($q) {
    $isMCEmpty = empty($q->multiple_choices_);
    return !$isMCEmpty;
  }    

  function getMultipleChoices($q) {
    $mc = $q->multiple_choices_;
    return $mc;
  }    

  function span($q) {
    $num = $this->isMultipleChoice($q) ? count($this->getMultipleChoices($q)) : 1;
    return $num;
  }    

  function cols($q) {
    $cols = array();

    if (empty($q->multiple_choices_)) {
     array_push($cols,$q->id_);     
    } else {
     
     $multi = $q->multiple_choices_;
     foreach ($multi as $choice) {
       array_push($cols,$choice->letter_);
     }       
    }      

    return $cols; 
  }    


  function getQuestionColumn($q) {
    $cols = array();

    if (empty($q->multiple_choices_)) {
      //$info = substr($q->question_,0,100);
      $info = $q->question_;
      array_push($cols,$info);     
    } else {
     
     $multi = $q->multiple_choices_;
     foreach ($multi as $choice) {
       //$info = substr($choice->choice_,0,15);
       $info = $choice->choice_;
       array_push($cols,$info);
     }       
    }      

    return $cols; 
  }    



  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("result-agent.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("result-agent.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("result-agent.php",$msg);  
  } 

  
}  



?>