
<?

class Survey {


  var $form_;
  var $questionid_;
  var $length_;
  var $userid_;
  var $html_;

  var $num_;
  

  function Survey($length = 10) {
    $this->form_ = new Form();
    $this->html_ = new HTMLMeta();
    $this->length_ = $length;
  }    

  function processUserId() {
    if (empty($this->userid_)) {
      global $userid;
      $meta = new UserMeta();
      $this->userid_ = (!empty($userid) && $meta->is($userid)) ? $userid : $meta->defaultt();
    }
  }    

  function processQuestion($qid) {
    global $date,$time, ${"answer$qid"};

    $userid = $this->userid_;
    $date = $this->form_->value($date,"");
    $answer = $this->form_->value(${"answer$qid"},"");
    
    $user = new UserMeta();
    $user->answered($userid,$qid);

    $agent = new AnswerAgent();
    $agent->save($qid,$userid,$date,$time,$answer);
  }    


  function process() {
    global $start,$questionid,$answer,$num;

    $this->processUserId();

    $isSubmit = !empty($answer);
    $isAnswered = $isSubmit && $answer == "Next";
    $isBack = $isSubmit && $answer == "Back";
    
    $meta = new QuestionMeta();

    $nextQuestion = $start;
    if ($isAnswered) {
      foreach ($questionid as $qid) {
        $this->processQuestion($qid);
        $nextQuestion = $qid+1;
      }
    } else if ($isBack) {
      $nextQuestion = $questionid[count($questionid)-1] - 2*$num + 1;
    }      

    $isQuestion = ($isBack) ? $meta->is($nextQuestion) : $meta->is($nextQuestion-1);
    $wasLastQuestion = $isQuestion && !$meta->is($nextQuestion);
    

    if (!$isQuestion) {
      $this->questionid_ = 1;
      $html = $this->html_->answering_;

    } else if ($wasLastQuestion) {
      $this->questionid_=-1;
      $html = $this->html_->done_;

    } else {
      $this->questionid_ = (integer)$nextQuestion;
      $html = $this->html_->answering_;
    }
    
    return $html;
  }


  function num() {
    $agent = new QuestionAgent("");
    return $agent->num();
  }    


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("_survey.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("_survey.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("_survey.php",$msg);  
  } 


}

?>
