<?

require_once("../_php/root.php");

global $root;

require_once($root->pathToTools() . "testcase.php");

require_once($root->pathToTestSuite()  . "test_root.php");
require_once($root->pathToTestSuite() . "test_answer-meta.php");
require_once($root->pathToTestSuite() . "test_broker.php");
require_once($root->pathToTestSuite() . "test_multiple-choice-meta.php");
require_once($root->pathToTestSuite() . "test_question.php");
require_once($root->pathToTestSuite() . "test_question-meta.php");
require_once($root->pathToTestSuite() . "test_user.php");
require_once($root->pathToTestSuite() . "test_user-meta.php");

if ($root->page() == "test_all.php") {
  $test = new AllTest();
  $test->runAll();
}    

class AllTest {

  var $passed_;
  var $failed_;
  var $title_;

  var $tests_;

  function AllTest($title = "AllTest") {
    global $passed;
    global $failed;

    $this->passed_ = $passed;
    $this->failed_ = $failed;
    
    $this->title_ = $title;

    $i = -1; 
    $this->tests_ = Array();
    $this->tests_[$i++] = new RootTest("test_all.php");
    $this->tests_[$i++] = new UserMetaTest();
    $this->tests_[$i++] = new UserTest();
    $this->tests_[$i++] = new QuestionMetaTest();
    $this->tests_[$i++] = new QuestionTest();
    $this->tests_[$i++] = new AnswerMetaTest();
  }    

  function doAll() {

    foreach($this->tests_ as $testcase) {
      $testcase->doAll();
    }   
    return $this->tests_;
  }    

  function runAll() {
    foreach($this->tests_ as $testcase) {
      $testcase->runAll();
    } 
  }   

  function debug($msg) {
    $debug_ = new Debug();
    $debug_->println("test_post.php",$msg);
  }

  function debug_r($msg) {
    $debug_ = new Debug();
    $debug_->println_r("test_post.php",$msg);
  }    

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("test_all.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("test_all.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("test_all.php",$msg);  
  } 


}



?>