
<?

require_once("../_php/root.php");

global $root;

global $start,$num,$ulow,$uhigh;

$form = new Form();

$start = $form->value($start,"1");
$num = $form->value($num,"50");

$userAgent = new UserAgent();
$userAgent->getUsersThatHaveCompletedSurvey();

$resultAgent = new ResultAgent($start,$num);


$questionAgent = new QuestionAgent();

$questions = $resultAgent->getQuestions();

$users = array();
while ($uid = $userAgent->next()) {
  $u = new User();
  $u->load($uid);
  array_push($users,$u);
}



?>


<html>
<head>
<title>Results</title>
<? $root->css(); $root->jscripts(); ?>
</head>

<body>

<table border=1>
  <tr>
    <td>QID</td>
    <td>Question</td>
    <td>Letter</td>
    <td>Options</td>

    <?
    foreach ($users as $u) {
      print "<td>$u->id_</td>";
    }      
    ?>    
  </tr>

  <?

  foreach ($questions as $q) {
     
     $type = $q->type_;
     
     $isRank = ($type == "rank");
     $isOpinion = ($type == "opinion");
     $isText = ($type == "textarea");
     $isInput = ($type == "input");
     $isCheckbox = ($type == "checkbox");
     $isRadio = ($type == "radio");

     if ($isRadio || $isCheckbox || $isRank) {

       $multipleChoices = $q->multiple_choices_;
       $rowspan = count($multipleChoices);

       print "<tr>";
       print "  <td rowspan='$rowspan'>$q->id_</td>";
       print "  <td rowspan='$rowspan'>$q->question_</td>";

       foreach ($multipleChoices as $mc) {
         $letter = $mc->letter_;
         $choice = $mc->choice_;
         $type = $q->type_;
         
         print "  <td>$letter</td>";
         print "  <td>$choice</td>";

         foreach ($users as $u) {
           $ans = $resultAgent->getUsersAnswer($u,$q,$letter) ;
           $empty =  "0";
           $checked = "1";
           $isEmpty = ($ans == "");
           $display = $isEmpty ? $empty : $checked;

           if (!$isEmpty) {
             $display = $isRank ? $ans : $checked;
           } else {
             $display = $empty;
           }             

           print "  <td>$display</td>";
         }           
                 
         print "</tr>";
       }         
     } else {
       print "<tr>";
       print "  <td>$q->id_</td>";
       print "  <td>$q->question_</td>";
       print "<td>&nbsp;</td>";
       print "<td>&nbsp;</td>";
       
       foreach ($users as $u) {
         $ans = $resultAgent->getUsersAnswer($u,$q,$q->id_) ;
         $display = ($ans == "") ? "0" : $ans;
         print "  <td>$display</td>";
       }         
       print "</tr>";
     }

  }    
   ?>
  
</table>

</body>
</html>
